%Variables del problema
m=1;          % masa [kg]
H=10;         % altura [m]
g=9.8;        % gravedad [m/s^2]
gamma=0:0.1:0.5;  %vector con los posibles valores de gamma
Tf=4;        %tiempo final 
dt=0.005;    % delta tiempo 
t=0:dt:Tf;   % vector tiempo
%Ahora vectores posicin y velocidad
x=zeros(length(gamma),length(t));  
dx=zeros(length(gamma),length(t));
%Condiciones de borde
x(:,1)=H;
dx(:,1)=0;
for i=1:length(t)-1
    dx(:,i+1)=dx(:,i)-g*dt-1/m*(gamma'.*dx(:,i))*dt;
    x(:,i+1)=x(:,i)+dx(:,i)*dt-0.5*(g+1/m*(gamma'.*dx(:,i)))*dt*dt;
    if (x(1,i)>=0 && x(1,i)<=0.05)
        t1=t(i);
    end
    if (x(2,i)>=0 && x(2,i)<=0.05)
        t2=t(i);
    end
    if (x(3,i)>=0)
        t3=t(i);
    end
    if (x(4,i)>=0 && x(4,i)<=0.05)
        t4=t(i);
    end
    if (x(5,i)>=0 && x(5,i)<=0.05)
        t5=t(i);
    end  
    if (x(6,i)>=0 && x(6,i)<=0.05)
        t6=t(i);
    end
end
Tcaida=[t1,t2,t3,t4,t5,t6]
Vsuelo=[dx(1,t1/dt),dx(2,t2/dt),dx(3,t3/dt),dx(4,t4/dt),dx(5,t5/dt),dx(6,t6/dt)]

set(gca,'NextPlot','replacechildren') % para poder escalar el grafico
figure(1)
axis([0 round(max(Tcaida)) 0 (H+1)])  % Varia el min y max de los ejes en cada direccion
plot(t,x(:,1:length(t)))    % Se graficara en pantalla la posicion x en funcion del tiempo
title('Caida con roce');
xlabel('Tiempo [seg]');
ylabel('Distancia [m]');
grid on

set(gca,'NextPlot','replacechildren')

figure(3)
axis([0 round(max(Tcaida)) round(min(Vsuelo)) 0])
plot(t,dx(:,1:length(t)))    % Se graficara en pantalla la velocidad dx en funcion del tiempo
title('Velocidad con roce');
 xlabel('Tiempo [seg]');
ylabel('Velocidad [m/s]');
grid on

figure(2)
plot(gamma,Vsuelo)            %grafica como varia la velocidad al llegar al suelo en funcion de gamma
title('velocidad v/s gamma');
xlabel('gamma [kg/s]');
ylabel('velocidad [m/s]');
grid on


figure(4)
subplot(1,3,1);plot(t,x(:,1:length(t)))    % Se graficara en pantalla la posicion x en funcion del tiempo
title('Caida con roce');
xlabel('Tiempo [seg]');
ylabel('Distancia [m]');
grid on
subplot(1,3,2);plot(t,dx(:,1:length(t)))    % Se graficara en pantalla la velocidad dx en funcion del tiempo
title('Velocidad con roce');
xlabel('Tiempo [seg]');
ylabel('Velocidad [m/s]');
grid on
subplot(1,3,3);plot(gamma,Vsuelo)
title('velocidad v/s gamma');
xlabel('gamma [kg/s]');
ylabel('velocidad [m/s]');
grid on



